﻿#region [ COPYRIGHT ]
//::|ññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññ|::
//::|ññ ---------------------------------------------------------------------------------- ññ|::
//::|ññ|                        ~ A R I E L   P R O D U C T I O N S ~                     |ññ|::
//::|ññ|                               ~ ALL RIGHTS RESERVED ~                            |ññ|::
//::|ññ ---------------------------------------------------------------------------------- ññ|::
//::|ññ| ~ PROGRAM DATA ~                                                       /-------/ |ññ|::
//::|ññ|                                                                      /-------/ | |ññ|::
//::|ññ| PROGRAMMER:: James Dougherty                                         | |     | | |ññ|::
//::|ññ| COPYRIGHT :: ©2009 Ariel Productions                                 | |     | | |ññ|::
//::|ññ|                                                                      | /-----|-/ |ññ|::
//::|ññ|                                                                      /-------/   |ññ|::
//::|ññ ---------------------------------------------------------------------------------- ññ|::
//::|ññ| ~ SOURCE DATA ~                                                                  |ññ|::
//::|ññ|                                                                                  |ññ|::
//::|ññ| FILENAME :: frmMain.cs                                                           |ññ|::
//::|ññ| VERSION  :: 0.1                                                                  |ññ|::
//::|ññ|                                                                                  |ññ|::
//::|ññ| HISTORY DATA                                                                     |ññ|::
//::|ññ| |                                                                                |ññ|::
//::|ññ| |-01.06.2009 JED v0.1 - Initial Build                                            |ññ|::
//::|ññ| |                                                                                |ññ|::
//::|ññ|                                                                                  |ññ|::
//::|ññ| BUGS                                                                             |ññ|::
//::|ññ| |                                                                                |ññ|::
//::|ññ| |-N/A                                                                            |ññ|::
//::|ññ| |                                                                                |ññ|::
//::|ññ|                                                                                  |ññ|::
//::|ññ ---------------------------------------------------------------------------------- ññ|::
//::|ññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññ|::
//::|ññ ---------------------------------------------------------------------------------- ññ|::
//::|ññ| This program is Copyright ©2009 Ariel Productions (James Dougherty). This        |ññ|::
//::|ññ| program is not in the public domain, therefore, it is not open source and all	  |ññ|::
//::|ññ| copyrights remain intact. This program constitutes proprietary information and   |ññ|::
//::|ññ| trade secrets of Ariel Productions, Ashland, Ohio. This program or any part of   |ññ|::
//::|ññ| this program may not be copied, sold, rented, leased, given, assigned, or        |ññ|::
//::|ññ| otherwise made available to any other individual or organization without the     |ññ|::
//::|ññ| written consent of Ariel Productions. Also, no part of this unpublished work may |ññ|::
//::|ññ| be reproduced, transmitted, or stored in a retrieval system. Nor can this        |ññ|::
//::|ññ| program be translated into any human or computer language in any form or by any  |ññ|::
//::|ññ| means electronically, mechanically, magnetically, optically, chemically, manual  |ññ|::
//::|ññ| or otherwise without the written permission of the copyright owner               |ññ|::
//::|ññ| (Ariel Productions). Contact information is listed below for more information.   |ññ|::
//::|ññ|                                                                                  |ññ|::
//::|ññ| Ariel Productions                                                                |ññ|::
//::|ññ| James Dougherty                                                                  |ññ|::
//::|ññ| jdougherty@arielproductions.com                                                  |ññ|::
//::|ññ| http://www.arielproducitons.com/                                                 |ññ|::
//::|ññ|                                                                                  |ññ|::
//::|ññ ---------------------------------------------------------------------------------- ññ|::
//::|ññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññññ|::
#endregion
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace RFID_Library
{
    public partial class frmMain : Form
    {
        #region [ Delegates ]
        private delegate void tagCallback(string data);
        private delegate void portErrorCallback(string data);
        private delegate void processMessageCallback(string data);
        private delegate void classWarningCallback(string data);
        private delegate void classExceptionCallback(string data);
        #endregion

        #region [ Class Variables ]
        private string dataBuffer = "";
        private ParallaxRFID parallaxRFID = null;
        #endregion

        #region [ Form Functions ]
        public frmMain()
        {
            InitializeComponent();
            InitializeInterface();
            InitializeRFID();
        }

        private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            CleanupRFID();
        }

        private void btnOpenPort_Click(object sender, EventArgs e)
        {
            CleanupRFID();
            InitializeRFID();

            parallaxRFID.InitializeCommunicationPort(cbComPorts.SelectedItem.ToString(), 3000);
            if (parallaxRFID.Initialized)
            {
                parallaxRFID.DTREnabled = false;
                parallaxRFID.OpenCommunicationPort();
            }
            SetInterfaceState(parallaxRFID.PortIsOpen);
        }

        private void btnClosePort_Click(object sender, EventArgs e)
        {
            parallaxRFID.CloseCommunicationPort();
            SetInterfaceState(parallaxRFID.PortIsOpen);
        }

        private void picFooter_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            e.Graphics.DrawString(lblAriel.Text, lblAriel.Font, new SolidBrush(lblAriel.ForeColor), lblAriel.Left - picFooter.Left, lblAriel.Top - picFooter.Top);
            e.Graphics.DrawString(lblProductions.Text, lblProductions.Font, new SolidBrush(lblProductions.ForeColor), lblProductions.Left - picFooter.Left, lblProductions.Top - picFooter.Top);
            e.Graphics.DrawString(lblCopyright.Text, lblCopyright.Font, new SolidBrush(lblCopyright.ForeColor), lblCopyright.Left - picFooter.Left, lblCopyright.Top - picFooter.Top);
        }
        #endregion

        #region [ Interface Functions ]
        private void InitializeInterface()
        {
            foreach (string port in System.IO.Ports.SerialPort.GetPortNames())
            {
                cbComPorts.Items.Add(port);
            }
            cbComPorts.SelectedIndex = 0;
        }

        private void SetInterfaceState(bool portOpened)
        {
            cbComPorts.Enabled = !portOpened;
            btnOpenPort.Enabled = !portOpened;
            btnClosePort.Enabled = portOpened;
        }
        #endregion

        #region [ Parallax RFID Class Functions ]
        private void InitializeRFID()
        {
            parallaxRFID = new ParallaxRFID();
            parallaxRFID.RFID_PortError += new ParallaxRFID.PortErrorDelegate(RFID_PortError);
            parallaxRFID.RFID_PinChanged += new ParallaxRFID.PinChangedDelegate(RFID_PinChanged);
            parallaxRFID.RFID_DataReceived += new ParallaxRFID.DataReceivedDelegate(RFID_DataReceived);
            parallaxRFID.RFID_ClassWarning += new ParallaxRFID.ClassWarningDelegate(RFID_ClassWarning);
            parallaxRFID.RFID_ClassException += new ParallaxRFID.ClassExceptionDelegate(RFID_ClassException);
        }

        private void CleanupRFID()
        {
            if (parallaxRFID != null)
            {
                parallaxRFID.Dispose();
                parallaxRFID = null;
            }
        }

        #region [ Callback Processing ]
        private void RFID_DataReceived(string data)
        {
            dataBuffer += data;
            Application.DoEvents();

            if (dataBuffer.Length == 12)
            {
                this.Invoke(new tagCallback(processTag), new object[] { dataBuffer.Substring(1, 10) });
                System.Threading.Thread.Sleep(1500);
                dataBuffer = "";
            }
        }

        private void RFID_PinChanged()
        {
            this.Invoke(new processMessageCallback(processMessage), new object[] { "Pin Changed" });
        }

        private void RFID_PortError(string data)
        {
            this.Invoke(new portErrorCallback(processPortError), new object[] { data });
        }

        private void RFID_ClassWarning(string data)
        {
            this.Invoke(new classWarningCallback(processClassWarning), new object[] { data });
        }

        private void RFID_ClassException(string data)
        {
            this.Invoke(new classExceptionCallback(processClassException), new object[] { data });
        }

        private void processMessage(string data)
        {
            txtDebug.Text += data + "\r\n";
            txtDebug.ScrollToCaret();
        }

        private void processPortError(string data)
        {
            txtDebug.Text += "[PORT ERROR] " + data + "\r\n";
            txtDebug.ScrollToCaret();
        }

        private void processClassWarning(string data)
        {
            txtDebug.Text += "[WARNING] " + data + "\r\n";
            txtDebug.ScrollToCaret();
        }

        private void processClassException(string data)
        {
            txtDebug.Text += "[EXCEPTION] " + data + "\r\n";
            txtDebug.ScrollToCaret();
        }
        #endregion
        #endregion

        #region [ Tag Processing ]
        //=======================================================================
        // Here is where the tag ID's will be processed. From here you can do
        // just about anything you want. For instance, you could query a databse.
        //-----------------------------------------------------------------------
        private void processTag(string text)
        {
            txtDebug.Text += "[TAG] " + text + "\r\n";
            txtTag.Text = text;

            switch (text)
            {
                case "0F03028F29":
                    txtName.Text = "James Dougherty";
                    break;

                default:
                    txtName.Text = "Unknown";
                    break;
            }
        }
        #endregion
    }
}
